$vms = Get-VM | where {$_.PowerState -eq "PoweredOff"}
$vmNames = New-Object System.Collections.ArrayList 
$vms | %{$vmNames.Add($_.Name)} | Out-Null 
Get-VIEvent -Start (Get-Date).AddDays(-7) -MaxSamples 99999 -Entity $vms | `
where {$_.GetType().Name -eq "VMPoweredOffEvent"} | %{
	if($vmNames -contains $_.VM.Name){
		$vmNames.Remove($_.VM.Name)
	}
}
$t = $vmNames | %{
	$row = "" | Select VMname
	$row.VMname = $_
	$row
}
$t | Export-Csv "C:\VM-poweredoff-longer-than-7-days.csv" -NoTypeInformation
